; dumb hacks to not have the message boxes in LM spoil anything.
; And also to alter some messages under certain conditions

!RAM_load_alt_level = $1F2B ; from dacin.asm

!RAM_challenge_message_flag = $0D9C ; from challenges.asm

org $83BBC9	; LM ROUTINE
	autoclean JML load_messagebox_tilemap
load_messagebox_tilemap_back = $83BBD5;:

freecode
load_messagebox_tilemap:
	;03BBD4
	REP #$30
		TXA
		ASL
		STA $00
		TYA
		CLC : ADC $00
		ASL
		TAX
		CPX.w #$00A4 ; 105-1 (coin game message)
		BEQ .load_alt_message_105_1
		CPX.w #$00A6 ; 105-2 (fish)
		BEQ .load_alt_message_105_2
		JML load_messagebox_tilemap_back

.load_alt_message_105_1
		LDA !RAM_challenge_message_flag-1
		BPL .normal_message
		AND #$7FFF
		STA !RAM_challenge_message_flag-1 ; unset flag
		LDX.w #message_tilemap_105_4-message_tilemap_105
		BRA .load
.normal_message
		LDX.w #message_tilemap_105_1-message_tilemap_105
		BRA .load
.load_alt_message_105_2
		LDA !RAM_load_alt_level
		AND #$0001
		BEQ .not_cleared ; not yet cleared. L+R is not enabled
		LDX.w #message_tilemap_105_3-message_tilemap_105
		BRA .load
.not_cleared
		LDX.w #message_tilemap_105_2-message_tilemap_105
.load
		PHB
		PEA $7F7F	; set DB to 7F
		PLB : PLB
		LDY $837B ; 7F837B
	SEP #$20
-	LDA.l message_tilemap_105,x
	STA $837D,y
	INX
	INY
	CMP #$FF
	BNE -
	DEY	; don't write FF byte to index
	STY $837B ; 7F837B
	PLB
	SEP #$10
	STZ $22
	STZ $24
	SEP #$30
	LDA #$01
	STA $13D5
	RTL

print "message_tilemap: $",hex(message_tilemap_105)," (0x",hex(snestopc(message_tilemap_105)+$200),")"
table "ascii-2a.txt"
message_tilemap_105:
.1
	db $50,$c7,$00,$23 :             dw "but really though,"
	db $50,$e7,$00,$23 :             dw "the  true question"
	db $51,$07,$00,$23 :             dw "of  this  level is"
	db $51,$27,$00,$23 :             dw "who  stole all the"
	db $51,$47,$00,$23 :             dw "coin  game clouds'"
	db $51,$67,$00,$23 :             dw "coins  and  1-ups?"
	db $51,$87,$00,$23 :             dw "All they do now is"
	db $51,$a7,$00,.l2-.l1-1 : .l1 : dw "fly away being very sad and stuff :(" : .l2 ; I'm not going to fix how the overflowing text stays after closing the msg box
	db $ff
.2
	db $50,$c7,$00,$23 : dw "Since  you clearly"
	db $50,$e7,$00,$23 : dw "like  playing with"
	db $51,$07,$00,$23 : dw "fish,  here's some"
	db $51,$27,$00,$23 : dw "Quality Gameplay",$397B,$397C ; TM
	db $51,$47,$00,$23 : dw "with   fish   made"
	db $51,$67,$00,$23 : dw "just for you :)   "
	db $51,$87,$00,$23 : dw "                ",$3960,$3961 ; Yoshi-Paw top row
	db $51,$a7,$00,$23 : dw "                ",$3962,$3963 ; Yoshi-Paw bottom row
	db $ff
.3
	db $50,$c7,$00,$23 : dw "Since  you clearly"
	db $50,$e7,$00,$23 : dw "like  playing with"
	db $51,$07,$00,$23 : dw "fish,  here's some"
	db $51,$27,$00,$23 : dw "Quality Gameplay",$397B,$397C ; TM
	db $51,$47,$00,$23 : dw "with   fish   made"
	db $51,$67,$00,$23 : dw "just for you :)   "
	db $51,$87,$00,$23 : dw "(Hold L+R for   ",$3960,$3961 ; Yoshi-Paw top row
	db $51,$a7,$00,$23 : dw "a bit to skip)  ",$3962,$3963 ; Yoshi-Paw bottom row
	db $ff
.4
	db $50,$c7,$00,$23 : dw "- CHALLENGE MODE -"
	db $50,$e7,$00,$23 : dw "Try to get the two"
	db $51,$07,$00,$23 : dw "other exits  with-"
	db $51,$27,$00,$23 : dw "out using 2 of the"
	db $51,$47,$00,$23 : dw "level's aspects.  "
	db $51,$67,$00,$23 : dw "An indicator  will"
	db $51,$87,$00,$23 : dw "show  up   if  you"
	db $51,$a7,$00,$23 : dw "trigger either.   "
	db $ff
; .4
	; db $50,$c7,$00,$23 : dw "- CHALLENGE MODE -"
	; db $50,$e7,$00,$23 : dw "Try to get the two"
	; db $51,$07,$00,$23 : dw "side exits without"
	; db $51,$27,$00,$23 : dw "using      certain"
	; db $51,$47,$00,$23 : dw "aspects   of   the"
	; db $51,$67,$00,$23 : dw "level   that   are"
	; db $51,$87,$00,$23 : dw "banned          in"
	; db $51,$a7,$00,$23 : dw "challenge mode    "
	; db $ff
; .5
	; db $50,$c7,$00,$23 : dw "There are 2 banned"
	; db $50,$e7,$00,$23 : dw "things    in   the"
	; db $51,$07,$00,$23 : dw "level.            "
	; db $51,$27,$00,$23 : dw "                  "
	; db $51,$47,$00,$23 : dw "An  indicator will"
	; db $51,$67,$00,$23 : dw "show   up  in  the"
	; db $51,$87,$00,$23 : dw "bottom-left if you"
	; db $51,$a7,$00,$23 : dw "trigger either.   "
	; db $ff
cleartable
